//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===
//   	Taken from PREYING MANTIS - by TseTse
//
//	
//	Special thanks to Sparky, v5planet, Red Shifter, and tons of
//	the #mapping crew for lots of great beta feedback.
//
//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===
// Audio

datablock AudioProfile(GateSoundEnter)
{
   filename    = "fx/powered/vehicle_screen_on.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(GateSoundExit)
{
   filename    = "fx/packs/shield_hit.wav";  
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(teleportparticle)
{
   dragCoefficient      = 1.5;
   gravityCoefficient   = 0.2;

   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;

   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   colors[0]     = "0.46 0.36 0.26 1.0";
   colors[1]     = "0.46 0.36 0.26 0.0";
   sizes[0]      = 0.65;
   sizes[1]      = 0.30;
};

datablock ParticleEmitterData(teleporterEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1.1;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;

   thetaMin         = 0.0;
   thetaMax         = 10.0;

   phiReferenceVel  = 0.0;    // All phi angles
   phiVariance      = 360.0;

   overrideAdvances = false;
   particles = "teleportparticle";
};


datablock ParticleData(teleportparticle1)
{
   dragCoefficient      = 0.0;   // Not affected by drag
   gravityCoefficient   = -0.0;   // ...or gravity
   windCoefficient      = 0.0;

   inheritedVelFactor   = 0.2;   // Do not inherit emitters velocity
   constantAcceleration = 0.0;   // No constant accel along initial velocity

   lifetimeMS           = 1000;  // lasts 1 second
   lifetimeVarianceMS   = 0;     // ...exactly

   textureName          = "particleTest";

   colors[0]     = "1 1 1 1";    // All white, no blending
   colors[1]     = "0 0 0.75 0.8";
   colors[2]     = "0 0.75 0 0.6";
   colors[3]     = "0.75 0 0 0.4";

   sizes[0]      = 0.1;            // One meter across
   sizes[1]      = 0.15;
   sizes[2]      = 0.2;
   sizes[3]      = 0.25;

};

datablock ParticleEmitterData(teleporterEmitter1)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3.1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 45.0;

   phiReferenceVel  = 0.0;    // All phi angles
   phiVariance      = 360.0;

   overrideAdvances = false;
   particles = "teleportparticle1";
};

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===
//   M A N T I S   G A T E - based on TAC2 teleporter
//
// Further code based on Labrat's MPBTeleporter 
// and the Havoc Teleporter code
//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===

datablock ItemData(NexusBase) 						

{
   catagory = "Objectives";
   shapefile = "Nexus_effect.dts";
   mass = 10;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 1.0; // default is 2
   icon = "CMDNexusIcon";
   targetTypeTag = 'ZenGate'; // default is nexus
   computeCRC = true;

};

datablock ItemData(TeleportClearGren)				
{
	className = Weapon;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 2;
   	maxDamage = 0.5;
	explosion = "";
	underwaterExplosion = "";
   	indirectDamage      = 0.0;
   	damageRadius        = 3.0;
   	radiusDamageType    = $DamageType::Default;
   	kickBackStrength    = 5000;
   	computeCRC = false;
};

package MantisGate {

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===

function Nexus_Effect::objectiveInit(%data, %object)			
{
   %object.playThread(0, "ambient");
   %object.setThreadDir(0, true);
   %object.flashThreadDir = true;
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===

function NexusBase::objectiveInit(%data, %object)			
{
   %object.playthread(0, "ambient");
   %object.setThreadDir(0, true);
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===

function NexusBase::onDamage(%this,%obj)				
{
	%obj.setDamageLevel(0);
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===

function ClearTeleportExit(%exit, %position)				
{
	%x = getWord(%position, 0);
	%y = getWord(%position, 1);
	%z = getWord(%position, 2) + 1;
	%newpos = %x SPC %y SPC %z;

	%thrownItem = new Item()
	{
		dataBlock = TeleportClearGren;
	};
	MissionCleanup.add(%thrownItem);				

	%thrownItem.setTransform(%newpos);
	schedule(400, %thrownItem, "detonateGrenade", %thrownItem);
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===
//                                ON COLLISION - TELEPORT
//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+====

function NexusBase::onCollision(%data, %obj, %colObj)  			// PARENT?
{
	//----------------------------------------------------------------------------
  	// Player Check

   	if((%colObj.getDataBlock().className !$= armor) || (%colObj.getState() $= "Dead"))
   		return;

	%player = %colObj;
	%client = %player.client;

	//----------------------------------------------------------------------------
	// Check direction

	%GateDirection = %obj.GateDirection;

	if(%GateDirection $= 1)
		{
		$GateRot1 = 270;
		$GateRot2 = 90;
		$GateY	= 3;
		}

	if(%GateDirection $= 2)
		{
		$GateRot1 = 90;
		$GateRot2 = 270;
		$GateY	= -3;
		}

	//----------------------------------------------------------------------------
	// TEAM Check

	   if(%obj.team == 0)  
   		{
		%TTgo = 1;
		}
		
	   else if(%obj.team == %player.team)
		{
		%TTgo = 1;
		}

	   else if(%player.team != %obj.team)  
		{
   		messageClient(%Client, 'MsgCantSitHere', '\c2wrong team...');
		%TTgo = 0;
		}

	   if(%TTgo == 0)
		{
		return;
		}

	if(%player.midTeleport)
		return;

	%TeleportExit = %obj.TeleportExit;

	if(%TeleportExit $= "")
		return;
	if(nameToId(%TeleportExit) == -1)
		return;

	// Houston, we are go for launch...

   	messageClient(%Client, 'MsgCantSitHere', '...Teleporting...');
	%player.setMoveState(true);  // Set player position above teleporter

	// WHIZ-BANG SPECIAL EFFECTS
		%GateRot1 = $GateRot1;

		%part99 = new ParticleEmissionDummy()
	            {
      			position = %teleposition;
      			rotation = "1 0 0 %GateRot1";
      			scale = "1 1 1";
      			dataBlock = "defaultEmissionDummy";
      			emitter = "teleporterEmitter";            
      			velocity = "1";
   		     };
        	%part98 = new ParticleEmissionDummy()
        	     {
      			position = %teleposition; 
      			rotation = "1 0 0 %GateRot1";
      			scale = "1 1 1";
      			dataBlock = "defaultEmissionDummy";
      			emitter = "teleporterEmitter2";            
      			velocity = "1";
   		     };

		%part97 = new ParticleEmissionDummy()  // Nexus_Effect()
			{
      			position = %teleposition; 
      			rotation = "1 0 0 %GateRot1";
      			scale = "1 1 1";
      			dataBlock = "defaultEmissionDummy";
      			emitter = "NexusParticleCapEmitter";            
      			velocity = "1";
			};

   		MissionCleanup.add(%part97);
   		%part97.schedule(1000,"delete");

   		MissionCleanup.add(%part99);
   		%part99.schedule(500,"delete");
   		MissionCleanup.add(%part98);
   		%part98.schedule(1500,"delete");

	// %obj.playAudio($PlaySound, GateSoundEnter);

	%position = nameToId(%TeleportExit).position;   // Toid?
	ClearTeleportExit(%TeleportExit, %position);

	%player.startFade(100, 0, true);
	%player.midTeleport = true;

	%data.schedule(200, "FinishTeleport", %obj, %TeleportExit, %player);

	// parent::onCollision(%data, %obj);
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+====

function NexusBase::FinishTeleport(%data, %obj, %exitobj, %player)		
{
	if(!nameToId(%exitobj).getDataBlock().CheckNexusEmpty(%exitobj))
	{
		%exitpos = %obj.position;
		%exitobj = %obj;
		messageClient( %client.player, 'MsgTeleportFailed', '\c2Teleport failed due to blockage at receiver pad.~wfx/misc/misc.error.wav' );
	}
	else
	{
		%exitpos = %exitobj.getPosition();
	}

	%x = getword(%exitpos, 0); 		// left of center
	%y = getword(%exitpos, 1) + $GateY;	// "forward" adjustment
	%z = getword(%exitpos, 2); 		// VERTICLE - was +1
	%start = %x SPC %y SPC %z;

	%player.setTransform(%start);					// Poof
	%player.startFade(200, 0, false);  
	%exitobj.playAudio($PlaySound, GateSoundExit);
	%data.schedule(100, "ImpulseTeleport", %player, %exitpos);

	// WHIZ-BANG SPECIAL EFFECTS
		%GateRot2 = $GateRot2;
		%part99 = new ParticleEmissionDummy()
	            {
      			position = %start; 		// %player.position
      			rotation = "1 0 0" SPC %GateRot2;
      			scale = "1 1 1";
      			dataBlock = "defaultEmissionDummy";
      			emitter = "teleporterEmitter";            
      			velocity = "1";
   		     };
        	%part98 = new ParticleEmissionDummy()
        	     {
      			position = %start; 
      			rotation = "1 0 0" SPC %GateRot2;
      			scale = "1 1 1";
      			dataBlock = "defaultEmissionDummy";
      			emitter = "teleporterEmitter2";            
      			velocity = "1";
   		     };

		%part97 = new ParticleEmissionDummy()  // Nexus_Effect()
			{
      			position = %teleposition; 
      			rotation = "1 0 0 %GateRot1";
      			scale = "1 1 1";
      			dataBlock = "defaultEmissionDummy";
      			emitter = "NexusParticleCapEmitter";            
      			velocity = "1";
			};

   		MissionCleanup.add(%part97);
   		%part97.schedule(3000,"delete");

   		MissionCleanup.add(%part99);
   		%part99.schedule(500,"delete");
   		MissionCleanup.add(%part98);
   		%part98.schedule(3500,"delete");
        				
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+====

function NexusBase::ImpulseTeleport(%data, %player, %exitpos)			
{
	%player.midTeleport = false;
	%player.setMoveState(false);
 
	if($GateY $= 3)
	{
	%player.applyImpulse(%exitpos, VectorScale("0 1 0", %player.getDataBlock().mass * 20)); 
	}

	if($GateY $= -3)
	{
	%player.applyImpulse(%exitpos, VectorScale("0 -1 0", %player.getDataBlock().mass * 20)); 

	// 
	}
	
	%player.playAudio($PlaySound, GateSoundEnter);
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+====

function NexusBase::CheckNexusEmpty(%data, %obj)				
{
	%loc = %obj.getPosition();
	%adjUp = VectorAdd(%loc, "0 0 1.0");   // don't go much below

	%avoidThese = $TypeMasks::MoveableObjectType | $TypeMasks::PlayerObjectType;
	if (ContainerBoxEmpty( %avoidThese, %adjUp, 2.0))
		return true;
	else
		return false;
}

//===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+===+====

function getVector(%string, %num)						
{
   %start = %num * 3;
   return getWords(%string,%start, %start + 2);
}

}; // end package

activatePackage (MantisGate);

